#!/usr/bin/perl

use CGI qw/:standard/;

do '../web-lib.pl';      
&init_config();          

&ReadParse();

$write_out=0;

@TCONFIG= split( '=|\n', `cat /etc/csav/update.conf` ); 
%CONFIG=( @TCONFIG );

my $crontab_loc = "/etc/crontab";
if ( $gconfig{'os_type'} =~ "solaris" ) { $crontab_loc = "/usr/spool/cron/crontabs/root"; };

header($text{'index_title'}, "");
if ($in{'name'})
{
    $write_out=1;
    $CONFIG{'NAME'}=$in{'name'};
}
if ($in{'password'})
{
    $write_out=1;
    $CONFIG{'PASSWORD'}=$in{'password'};
}
if ($in{'download'})
{
    $write_out=1;
    $CONFIG{'SITE'}=$in{'download'};
}
if ($in{'when'})
{
    $write_out=1;
    $CONFIG{'WHEN'}=$in{'when'};
}
if ($in{'time'})
{
    $write_out=1;
    $CONFIG{'TIME'}=$in{'time'};
}
if ($in{'enabled'})
{
    $write_out=1;
    $CONFIG{'ENABLED'}=$in{'enabled'};
}

( $hour, $minute ) = split( ':', $CONFIG{'TIME'} );

$hour = int( $hour );
$minute = int( $minute );

$hour = 0 if ($hour < 0);
$hour = 23 if ($hour>23 );
$minute = 0 if ($minute <0 || $minute > 59);

$CONFIG{'TIME'}="$hour:$minute";

print start_form;
print table({-border=>undef},
            Tr({-align=>left,-valign=>TOP},
                  [ 
		   td([ $text{'enabled'}, popup_menu(
			-name=>'enabled',
			-values=>[ 'Yes', 'No' ],
			-defaults=>$CONFIG{'ENABLED'}) ]),
		   td([ $text{'user_name'},textfield(-name=>'name',-value=>$CONFIG{'NAME'})     ]),
                   td([ $text{'user_pw'},  textfield(-name=>'password',-value=>$CONFIG{'PASSWORD'}),]),
		   td([ $text{'sel_site'}, popup_menu(
                       -name=>'download',
                       -values=>['ftp.command.co.uk','ftp.commandsoftware.com','ftp.command.co.au','download.commandsoftware.com'],
		       -defaults=>$CONFIG{'SITE'})
                                ]),
		   td([ $text{'when'}, radio_group(
                       -name=>'when',
                       -values=>['hourly','daily','weekly','monthly'],
		       -default=>$CONFIG{'WHEN'},  
                       -columns=>1 )
	             ]), 
		    td([ $text{'time'}, textfield(-name=>'time',-value=>$CONFIG{'TIME'},-size=>5)]),
		  ]
	      ) 
          );
print submit(-name=>$text{'submit'});
print end_form;
## Some debugging help to figure out OS and location of crontab
#		    td([ $text{'OS'}, "$gconfig{'os_type'}, $crontab_loc" ]) 

if ($write_out)
{
    open( out, "> /etc/csav/update.conf" );
    print( out "ENABLED=$CONFIG{'ENABLED'}\n" );
    if ( $CONFIG{'SITE'} =~ /ftp/ )
    {
    	print( out "PROTO=ftp\n" );
	    print( out "SITE=$CONFIG{'SITE'}/products/commercial/def\n" );
    }
    else
    {
	    print( out "PROTO=http\n" );
	    print( out "SITE=$CONFIG{'SITE'}/csav/deffiles\n" );	    
    }
    print( out "NAME=$CONFIG{'NAME'}\n" );	    
    print( out "PASSWORD=$CONFIG{'PASSWORD'}\n" );
    print( out "WHEN=$CONFIG{'WHEN'}\n" );
    print( out "TIME=$CONFIG{'TIME'}\n" );
    close( out );
# todo update $crontab_loc
    $line = "";
    if ( $CONFIG{'WHEN'} eq 'hourly' )
    {
	$line = "$minute * * * * root /usr/local/bin/csavupdate.sh";
    }
    if ( $CONFIG{'WHEN'} eq 'daily' )
    {
	$line = "$minute $hour * * * root /usr/local/bin/csavupdate.sh";
    }
    if ( $CONFIG{'WHEN'} eq 'weekly' )
    {
	$line = "$minute $hour * * sun root /usr/local/bin/csavupdate.sh";
    }
    if ($CONFIG{'WHEN'} eq 'monthly' )
    {
	$line = "$minute $hour 1 * * root /usr/local/bin/csavupdate.sh";
    }
    $name="/tmp/csavupdate.tmp";
    system( "cat $crontab_loc | grep -v csavupdate > $name" );
    system( "echo \"$line\" >> $name" ) if ($CONFIG{'ENABLED'} eq "Yes");
    system( "mv $name $crontab_loc" );
}


footer("/", $text{'index'});
